;==============================================================================
;
;	proba02.ASM		HARDWARE HASZNLATTAL
;
;	1. rai AVR ASM MSODIK progi
;
;	F7:      Assemble,		
;	Ctrl+F7: Assemble and Run
;	F11:	 Step
;
;	NAGYON FONTOS !!!!
;		A szerkeszthet forrsllomny kiterjesztse:  .asm
;		Ilyen .asm kiterjeszts, megfelel forrsllomnyt kell a MOODLE-ba 
;		feltlteni!
;
;		A fordts utn a valdi eszkzre, azaz a BOARD-ra a .hex kiterjeszts
;		llomnyt kell feltlteni! 
;
;		Ha a hallgatk nem tudjk a NagyZH-kon, hogy mi a szerkeszthet
;		forrsllmny (.asm), amit fel kell tlteni a MOODLE-ba, az bukst jelent!
;		Az oktat a NagyZH-n mr nem mondhatja el a forrsllomny kiterjesztst!
;		Ugyanez vonatkozik a feltltsre is, azaz a .hex file-ra.
;		
;------------------------------------------------------------------------------
;
;	DDRx  (8bit)	Data Direction (O:be, 1:ki) ( PORT irny bellits)
;	PORTx (8bit)	1 PORT kimeneti rtknek a belltsa (0: 0V, 1: 5V)
;	PINx  (1bit)	1 lb  kimeneti rtknek a belltsa (0: 0V, 1: 5V)
;
;==============================================================================

;==============================================================================
; 5. FELADAT: kt szm sszeadsa (r17,r18), s az eredmny kirsa a LED-ekre 
;
;	FONTOS: Els lpsben az egyes regiszterek,flag-ek s PC (Program Counter)
;		rtkeinek vltozst szimultorban kvessk nyomon.
;
;		A program megrtse utn tltsk fel az eszkzre
;------------------------------------------------------------------------------

.include "m128def.inc"	; definicis file 

.org	0x0		; kezdcm, innen indul a progi, RESET vektor kezdete
	jmp start	; start cimkre elugrik

			; 0x0 cim s a 0x100 cm kztt a megszaktsok vannak
.org	0x100		; ezrt ezt a terletet ki kell hagyni
start:

; ---- Szmols (sszeads 1 BYTE-os szmokkal) ---- ---- ---- ---- ---- ---- ----

	ldi r17, 16		; r17-be 16 decimlisan (1 BYTE-os szm)
	ldi r18,  6		; r18-be  4 decimlisan (1 BYTE-os szm)
	add r17, r18		; 2 regiszter sszeadsa, eredmny r17-ban keletkezik

; ---- PORTB s PORTD lbainak BEmenetre s KImenetre lltsa ---- ---- ----

				; a ksbbiekben a PORT belltsokat elre tesszk
	ldi r16,  0b11110000	; segdvltoz a kimenetek belltshoz
	out DDRB, r16		; B PORT fels 4 bitje kimenet lesz, als 4 bit bemenet
	out DDRD, r16		; D PORT fels 4 bitje kimenet lesz, als 4 bit bemenet

; ---- Szmols utn az eredmny kiraksa a PORTB-re s PORTD-re ---- ---- ----

	out PORTD, r17	; r17 fels 4 bitjt kirakjuk, PORTD-re (!!!)
	swap r17	; r17 fels 4 s als 4 bitjt fel kell cserlni
	out PORTB, r17	; r17 als  4 bitjt kirakjuk, PORTB-re (!!!)
	swap r17	; swap vissza, eredeti szm (r17) visszalltsa (BAB)

stop:			; itt prg a progi
	jmp stop

